#include "winpf.h"

#pragma comment(lib, "user32")	// needed by linker to satisfy wvsprintf()

/*	Tiny w_xxx "printf" functions to replace equivalent C runtime versions.
	See winpf.h for more info.
*/
int w_printf(char *pFmt, ...) {
	int i;
	va_list vl;
	va_start(vl, pFmt);
	i = w_vfprintf(W_STDOUT, pFmt, vl);
	va_end(vl);
	return i;
}
int w_sprintf(char *pOut, char *pFmt, ...) {
	va_list vl;
	int i;
	va_start(vl, pFmt);
	i = wvsprintf(pOut, pFmt, vl);
	va_end(vl);
	return i;
}
int w_fprintf(HANDLE h, char *pFmt, ...) {
	int i;
	va_list vl;
	va_start(vl, pFmt);
	i = w_vfprintf(h, pFmt, vl);
	va_end(vl);
	return i;
}
int w_vfprintf(HANDLE h, char *pFmt, va_list vl) {
	char obuf[3 * 1024];				// temporary result buffer
	DWORD bio;
	char *pw = obuf;
	char *ph = obuf + sizeof(obuf) / 2;	// halfway point
	int i = wvsprintf(ph, pFmt, vl);
	if (i <= 0) return i;

	do {								// map \n to \r \n
		char c = *ph++;
		if (c == '\n') *pw++ = '\r';
		*pw++ = c;
	} while (--i);
	i = (int) (pw - obuf);				// i= non-zero len of mapped string

	if ((size_t) h >= (size_t) -128) { // if W_STD... constant,
		h = GetStdHandle((DWORD) (size_t) h); // h= true HANDLE
	}
	if (!WriteFile(h, obuf, i, &bio, NULL)) i = -1;
	return i;
}
